﻿
# Installation d'un serveur Debian/Stretch sécurisé

### Résumé

Nous allons procéder à l'installation d'un serveur “maison”, sécurisé dans la mesure du possible, avec explications et tests, afin de comprendre le pourquoi et le comment.
Nous utiliserons la distribution Debian dans sa dernière mouture : Stretch.

Ce ne sera pas “un tutoriel à suivre pas à pas”, mais plutôt un ensemble d'étapes qui permettront d'installer et configurer SON serveur. Chaque étape sera accompagnée de tests pour en vérifier le fonctionnement.

Certains services seront installés, comme un serveur de courriers (Postfix), un serveur DNS bind9, un serveur Web (Apache), un bouncer IRC, un serveur Git.
Nous aurions pu faire d'autres choix, comme Unbound (DNS), Citadel (courrier), etc.

1. [Installation du système de base](/1-un.md)
2. [Première étapes de sécurisation du serveur](/2-deux.md)
3. [Configuration du réseau](/3-trois.md)
4. [Installation d'un serveur de temps](/4-quatre.md)
5. [Installation d'un pare-feu](/5-cinq.md)
6. [Contrer les attaques de brute-force avec fail2ban](/6-six.md)
7. [Installation d'un serveur de courrier basique](/7-sept.md)
8. [Installation du serveur DNS](/8-huit.ms)
9. [Installation d'un serveur web](/9-neuf.md)
10. [Installation de dovecot et de l'authentification](/10-dix.md)
11. [Installation des certificats letsencrypt](/11-onze.md)
12. [Ajout des enregistrements **spf**, **DKIM**, **DMARC** au fichier de zone DNS](/12-douze.md)
13. [Ajout des comptes émail virtuels](/13-treize.md)
14. [Installation de programmes de surveillance du serveur](/17-dixsept.md))
15. [Installation d'un webmail (rainloop)](/18-un.md)
[//]: # (16. [Ajout de DNSSEC]())
[//]: # (17. [Ajout des enregistrements DANE]())
[//]: # (18. [Gestion de clefs«  SSH multiples](/14-quatorze.md))
[//]: # (19. [Utilisation d'une carte à puce pour s'authentifier])(/15-quinze.md)
[//]: # (20. [Utilisation d'un lecteur NFC et de tags](/16-seize.md))

**Note**: j'ai voulu utiliser le format **Markdown** pour écrire ce tuto; une manière de tester, d'apprendre le markdown. J'avoue qu'après des années d'utilisation de LaTeX et de Docbook, j'ai vraiment galéré: j'ai mis en place des vérificateurs de syntaxe markdown, utilisé des éditeurs spécialisés comme Stackedit, Dillinger, des extensions spécifiques à VisualCode, SublimeText ou Atom. Toutes ces solutions donnent un markdown valide différent, qui n'est pas transformé correctement si on change de convertisseur. Je sais qu'il y a plusieurs versions de markdown, mais elles pourraient être compatibles entre elles. Des outils comme **mkdocs** sont remarquables, mais markdown, pas à mon goût. J'aime ce qui est clair et reproductible.
